/**
 * Receives notifications of new peers joining the network that support the DHT protocol
 */
export class TopologyListener extends EventEmitter {
    /**
     * Create a new network
     *
     * @param {object} params
     * @param {import('libp2p/src/registrar')} params.registrar
     * @param {string} params.protocol
     * @param {boolean} params.lan
     */
    constructor({ registrar, protocol, lan }: {
        registrar: import('libp2p/src/registrar');
        protocol: string;
        lan: boolean;
    });
    _log: debug.Debugger & {
        error: debug.Debugger;
    };
    _running: boolean;
    _registrar: import("libp2p/src/registrar");
    _protocol: string;
    /**
     * Start the network
     */
    start(): Promise<void>;
    _registrarId: string | undefined;
    /**
     * Stop all network activity
     */
    stop(): void;
}
import { EventEmitter } from "events";
//# sourceMappingURL=topology-listener.d.ts.map